package com.iamberry.wechat.handles.integral;

import com.iamberry.wechat.core.entity.ResultMsg;
import com.iamberry.wechat.core.entity.WechatUtils;
import com.iamberry.wechat.core.entity.integral.StayIntegral;
import com.iamberry.wechat.core.entity.integral.UseIntegral;
import com.iamberry.wechat.core.entity.member.Member;
import com.iamberry.wechat.core.entity.product.Product;
import com.iamberry.wechat.face.integral.UseIntegralService;
import com.iamberry.wechat.tools.NameUtils;
import com.iamberry.wechat.tools.ResultInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import java.text.SimpleDateFormat;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by Administrator on 2018/1/23.
 */
@Controller
@RequestMapping("/admin/userIntegral")
public class AdminIntegrlhHandler {

    @Autowired
    private UseIntegralService useIntegralService;
    /**
     * 查询积分记录 并分页 (支持查询条件模糊搜索)
     * 2018年2月24日
     * @author mzx
     * @param pageNO	分页信息
     * @return
     */
    @RequestMapping("/listIntegral")
    public ModelAndView listIntegral(@RequestParam(value= "pageSize",defaultValue= "10" ,required=false) Integer pageSize,
                                     @RequestParam(value = "pageNO", defaultValue = "1",required=false) Integer pageNO,
                                     HttpServletRequest request) throws Exception {
        StringBuffer url = new StringBuffer("/admin/product/list?pageSize=" + pageSize);
        ModelAndView mv = new ModelAndView("admin/product/productList");
        String userName = request.getParameter("userName");
        String userNikeName = request.getParameter("userNikeName");
        String integralNumberMax = request.getParameter("integralNumberMax");
        String integralNumberMin = request.getParameter("integralNumberMin");
        UseIntegral useIntegral=new UseIntegral();
        useIntegral.getPage().setPageSize(pageSize);
        useIntegral.getPage().setPageNumber(pageNO);

        if (null != userName && !"".equals(userName)) {
            useIntegral.setUserName(userName);
            url.append("&userName=" + userName);
        }
        if (null != userNikeName && !"".equals(userNikeName)) {
            url.append("&userNikeName=" + userNikeName);
            useIntegral.setUserNickname(userNikeName);
        }
        if (null != integralNumberMax && !"".equals(integralNumberMax)) {
            url.append("&integralNumberMax=" + integralNumberMax);
            useIntegral.setIntegralNumberMax(integralNumberMax);
        }
        if (null != integralNumberMin && !"".equals(integralNumberMin)) {
            url.append("&integralNumberMin=" + integralNumberMin);
            useIntegral.setIntegralNumberMin(integralNumberMin);
        }

        List<UseIntegral> list = useIntegralService.listUseIntegral(useIntegral);
        mv.addObject("list", list);

        url.append("&pageNO=");
        int count = useIntegralService.listUseIntegralCount(useIntegral);
        int pageCount =  count % useIntegral.getPage().getPageSize() == 0? count/useIntegral.getPage().getPageSize():(count/useIntegral.getPage().getPageSize())+1;
        //分页用
        mv.addObject("pageNO", pageNO);
        mv.addObject("url", url);
        mv.addObject("userName", userName);
        mv.addObject("userNikeName", userNikeName);
        mv.addObject("integralNumberMax", integralNumberMax);
        mv.addObject("integralNumberMin", integralNumberMin);
        mv.addObject("pageSize", pageCount);
        return mv;
    }

    /**
     * 查询待入账积分记录 并分页 (支持查询条件模糊搜索)
     * 2018年2月24日
     * @author mzx
     * @param pageNO	分页信息
     * @return
     */
    @RequestMapping("/listStayIntegral")
    public ModelAndView listStayIntegral(@RequestParam(value= "pageSize",defaultValue= "10" ,required=false) Integer pageSize,
                                         @RequestParam(value = "pageNO", defaultValue = "1",required=false) Integer pageNO,
                                         HttpServletRequest request) throws Exception {
        StringBuffer url = new StringBuffer("/admin/product/list?pageSize=" + pageSize);
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        ModelAndView mv = new ModelAndView("admin/product/productList");
        String integralRemark = request.getParameter("integralRemark");
        String userName = request.getParameter("userName");
        String userNikeName = request.getParameter("userNikeName");
        String stayRecordedTime = request.getParameter("stayRecordedTime");
        String changeIntegralMax = request.getParameter("changeIntegralMax");
        String changeIntegralMin = request.getParameter("changeIntegralMin");
        StayIntegral stayIntegral=new StayIntegral();
        stayIntegral.getPage().setPageSize(pageSize);
        stayIntegral.getPage().setPageNumber(pageNO);


        if (null != integralRemark && !"".equals(integralRemark)) {
            stayIntegral.setIntegralRemark(integralRemark);
            url.append("&integralRemark=" + integralRemark);
        }
        if (null != userName && !"".equals(userName)) {
            stayIntegral.setUserName(userName);
            url.append("&userName=" + userName);
        }
        if (null != userNikeName && !"".equals(userNikeName)) {
            url.append("&userNikeName=" + userNikeName);
            stayIntegral.setUserNickname(userNikeName);
        }
        if (null != stayRecordedTime && !"".equals(stayRecordedTime)) {
            url.append("&stayRecordedTime=" + stayRecordedTime);
            stayIntegral.setStayRecordedTime(format.parse(stayRecordedTime));
        }
        if (null != changeIntegralMax && !"".equals(changeIntegralMax)) {
            url.append("&changeIntegralMax=" + changeIntegralMax);
            stayIntegral.setChangeIntegralMax(Integer.valueOf(changeIntegralMax));
        }
        if (null != changeIntegralMin && !"".equals(changeIntegralMin)) {
            url.append("&changeIntegralMin=" + changeIntegralMin);
            stayIntegral.setChangeIntegralMin(Integer.valueOf(changeIntegralMin));
        }

        List<StayIntegral> list = useIntegralService.listAdminStayIntegral(stayIntegral);
        mv.addObject("list", list);

        url.append("&pageNO=");
        int count = useIntegralService.listAdminStayIntegralCount(stayIntegral);
        int pageCount =  count % stayIntegral.getPage().getPageSize() == 0? count/stayIntegral.getPage().getPageSize():(count/stayIntegral.getPage().getPageSize())+1;
        //分页用
        mv.addObject("pageNO", pageNO);
        mv.addObject("url", url);
        mv.addObject("integralRemark", integralRemark);
        mv.addObject("userName", userName);
        mv.addObject("userNikeName", userNikeName);
        mv.addObject("stayRecordedTime", stayRecordedTime);
        mv.addObject("changeIntegralMax", changeIntegralMax);
        mv.addObject("changeIntegralMin", changeIntegralMin);
        mv.addObject("pageSize", pageCount);
        return mv;
    }

    @ResponseBody
    @RequestMapping("/updatestayIntegralStatus")
    public ResultMsg updatestayIntegralStatus(HttpServletRequest request){
        ResultMsg resultMsg = new ResultMsg();
        String stayId = request.getParameter("stayId");
        String stayStatus = request.getParameter("stayStatus");
        if (null == stayId || "".equals(stayId)) {
            resultMsg.setStatus(false);
            resultMsg.setResultCode("200");
            return resultMsg;
        }
        if (null == stayStatus || "".equals(stayStatus)) {
            resultMsg.setStatus(false);
            resultMsg.setResultCode("200");
            return resultMsg;
        }
        StayIntegral stayIntegral = new StayIntegral();
        stayIntegral.setStayId(Integer.valueOf(stayId));
        stayIntegral.setStayStatus(Integer.valueOf(stayStatus));
        Integer msg = useIntegralService.updatestayIntegralStatus(stayIntegral);
        if(msg < 1){
            resultMsg.setStatus(false);
            resultMsg.setResultCode("200");
            return resultMsg;
        }else{
            resultMsg.setStatus(true);
            resultMsg.setResultCode("200");
            return resultMsg;
        }
    }
}
